var Manager = function () {
    var self = this,
        ajax = function (url, data, successFun, errorFun, refreshInSuccess, cleanClassName) {
            $.ajax({
                type: "POST",
                url: url,
                data: data,
                datatype: "html",
                success: function (data) {
                    if (data.length == 0) {
                        if (errorFun) errorFun(data);
                        return;
                    }

                    var respJson = eval('(' + data + ')');

                    if (respJson.StatusCode == 200) {
                        if (successFun) {
                            successFun(respJson);
                        } else {
                            if (respJson.Message == null || respJson.Message.length == 0) return;

                            $.toast({
                                text: respJson.Message,
                                position: 'mid-center',
                                icon: 'success',
                                afterHidden: function () {
                                    if (refreshInSuccess) {
                                        location.href = "/" + respJson.Lang + "/" + respJson.Controller + "/" + respJson.Action;
                                    } else {
                                        if (cleanClassName != null && cleanClassName.length > 0) {
                                            self.cleanCheckBox(cleanClassName);
                                        }
                                    }
                                }
                            });
                        }
                    } else {
                        if (errorFun) errorFun(respJson.Message);
                        else {
                            if (respJson.Message == null || respJson.Message.length == 0) return;

                            $.toast({
                                text: respJson.Message,
                                position: 'mid-center',
                                icon: 'error'
                            });
                        }
                    }
                },
                error: function (data) {
                    if (data.status == 401) {
                        $.toast({
                            text: gStrLoginTime,
                            position: 'mid-center',
                            icon: 'error',
                            afterHidden: function () {
                                window.location.reload();
                            }
                        });
                    }
                }
            });
        };
    self.cleanCheckBox = function (className) {
        var chkBoxs = document.getElementsByClassName(className);
        for (var i = 0; i < chkBoxs.length; i++) {
            chkBoxs[i].checked = false;
        }
    };
    self.selectLang = function () {
        var href = window.location.href;
        var lang = $.cookie("currentLang");
        if (lang && href.indexOf(lang) >= 0) {
            $("#lang-slt").val(lang);
        }
        $("#lang-slt").on("change", function (e) {
            var sltLang = $(this).find("option:selected").val();
            $.cookie("currentLang", sltLang, { path: "/", expires: 7 });
            if ($.browser.safari) {
                var click_ev = document.createEvent("MouseEvents");
                click_ev.initEvent("click", true, true);
                document.getElementById(sltLang).dispatchEvent(click_ev);
            } else {
                document.getElementById(sltLang).click();
            };
        });
    };
    self.selectMenu = function () {
        var href = window.location.href;
        var hrefArr = href.split("/");
        var pageName = hrefArr[hrefArr.length - 1];
        $("#" + pageName).addClass("menu-active");
    };
    self.ajaxPost = function (url, data, refreshInSuccess, cleanClassName) {
        if (!cleanClassName) { cleanClassName = null };
        ajax(url, data, null, null, refreshInSuccess, cleanClassName);
    };
    self.ajaxPostEx = function (url, data, successFun, errorFun) {
        ajax(url, data, successFun, errorFun, false, null);
    };
    self.selectAll = function (sender, tableId, className) {
        var chkBoxs = $("." + className);
        var chk = $(sender).is(":checked");

        if (chk) {
            $("#" + tableId + " tr").addClass('selected');
        } else {
            $("#" + tableId + " tr").removeClass('selected');
        }

        for (var i = 0; i < chkBoxs.length; i++) {
            chkBoxs[i].checked = chk;
        }
    };
    self.loadXML = function (xmlString) {
        var xmlDoc = null;
        if (!window.DOMParser && window.ActiveXObject) {
            var xmlDomVersions = ['MSXML.2.DOMDocument.6.0', 'MSXML.2.DOMDocument.3.0', 'Microsoft.XMLDOM'];
            for (var i = 0; i < xmlDomVersions.length; i++) {
                try {
                    xmlDoc = new ActiveXObject(xmlDomVersions[i]);
                    xmlDoc.async = false;
                    xmlDoc.loadXML(xmlString);
                    break;
                } catch (e) { }
            }
        }
        else if (window.DOMParser && document.implementation && document.implementation.createDocument) {
            try {
                domParser = new DOMParser();
                xmlDoc = domParser.parseFromString(xmlString, 'text/xml');
            } catch (e) { }
        }
        else {
            return null;
        }
        return xmlDoc;
    };
    self.getIds = function (className) {
        var chkBoxs = $("." + className);
        var ids = new Array();

        for (var i = 0; i < chkBoxs.length; i++) {
            var chkBox = chkBoxs[i];

            if (chkBox.checked) {
                ids[ids.length] = chkBox.id;
            }
        }
        return ids;
    };
    self.tipToast = function (message, positive) {
        var toastType = positive ? "success" : "error";

        $.toast({
            text: message,
            position: 'mid-center',
            icon: toastType,
            stack: false
        });
    };
    self.clearDatatables = function () {
        var wrappers = document.getElementsByClassName("dataTables_wrapper");
        if (wrappers != null && wrappers.length > 0) {
            for (var i = 0; i < wrappers.length; i++) {
                var wrapper = wrappers[i];
                var tables = wrapper.getElementsByClassName("dataTable");

                if (tables != null && tables.length > 0) {
                    for (var j = 0; j < tables.length; j++) {
                        var table = tables[i];
                        try {
                            table.style.width = "";
                        } catch (e) {}
                    }
                }
            }
        }
    };
};

(function () {
    $.fManager = new Manager();
    $.fManager.selectLang();
    $.fManager.selectMenu();

    $.fn.watch = function (callback) {
        return this.each(function () {
            $.data(this, 'originVal', $(this).val());
            $(this).on('keyup paste', function () {
                var originVal = $.data(this, 'originVal');
                var currentVal = $(this).val();

                if (originVal !== currentVal) {
                    $.data(this, 'originVal', $(this).val());
                    callback(currentVal);
                }
            });
        });
    };

    $(".modal").on('hidden.bs.modal', function () {
        var btns = $(this).find("button");
        for (var i = 0; i < btns.length; i++) {
            $(btns[i]).unbind();
        }
    });

    $.fHover = function (options) {
        $(window).scroll(function () {
            var targetWidth = $(options.parent).width() - 30;
            var oTop = $(options.parent).offset().top;
            var scrollTop = $(window).scrollTop();
            if (scrollTop > oTop && $(options.parent).is(":visible")) {
                $(options.target).css({ "position": "fixed", "z-index": 9, "top": "60px", "border-right": "1px solid #ddd" });
                $(options.target).width(targetWidth);
            } else {
                $(options.target).css({ "position": "static", "border-right": "none" ,"width":"100%"});
            }
        });
    };
})();